unit uTabsActores;

{$mode delphi}

interface

uses
  Classes, SysUtils, contnrs, ucosa, ueditor_resourcestrings,


  //***** Red Electrica *****
  unodos, uArcos, uArcoConSalidaProgramable,

  //***** Demandas *****
  udemandas01, udemandadetallada, uDemandaAnioBaseEIndices,

  //***** Eolicos *****
  uParqueEolico, uParqueEolico_vxy,

  //***** Solar *****
  usolartermico, usolarpv,

  //***** Termicos *****
  ugter_basico, ugter_onoffporpaso, ugter_onoffporposte, ugter_arranqueparada,
  ugter_basico_trep, ugter_basico_PyCVariable, ugter_onoffporpaso_conrestricciones,
  ugter_combinado, ubiomasaembalsable,
  {$IFDEF COMBUSTIBLES}
    ugter_onoffporposteV2,
    ugter_onoffporpasoV2,
    ugter_arranqueparadaV2,
    ugter_combinadoV2,
  {$ENDIF}

  //***** Hidroelectrica *****
  uHidroConEmbalse, uHidroConBombeo, uHidroDePasada, uHidroConEmbalseBinacional,

  //***** Comercio internacional y otros *****
  uMercadoSpot, uMercadoSpotConDetalleHorarioSemanal, ucontratomodalidaddevolucion,
  uMercadoSpot_postizado, ubancodebaterias01,

  //***** Usos gestionables *****
  uusogestionable_postizado,

  //***** Combustibles *****
  unodocombustible, udemandaCombustibleAnioBaseEIndices, uregasificadora,
  uArcoCombustible, ugsimple_bicombustible, uTSumComb
  ;

type

  { TVirtualTableTabs }

  TVirtualTableTabs=class(TDataVTableOfCosa)

    constructor Create(TabCaption: string); overload;

  end;

  { TTabsActores }

  TTabsActores=class(TFPHashList)

    function Add(const TabCaption: shortstring; vdt: TVirtualTableTabs): Integer;
    function Find(const TabCaption: shortstring): TDataVTableOfCosa;

    function TabsNames:TStringList;

  end;


  var
    tabsActores:TTabsActores;


procedure CrearTabsActores;




implementation

procedure CrearTabsActores;
var
  vdt:TVirtualTableTabs;
begin

  // Red electrica
  vdt:=TVirtualTableTabs.Create(strTabRed);
  vdt.AddChildClassName(TNodo.ClassName);
  vdt.AddChildClassName(TArco.ClassName);
  vdt.AddChildClassName(TArcoConSalidaProgramable.ClassName);

  tabsActores.Add(strTabRed, vdt);

  // Demandas
  vdt:=TVirtualTableTabs.Create(strTabDemandas);
  vdt.AddChildClassName(TDemanda01.ClassName);
  vdt.AddChildClassName(TDemandaDetallada.ClassName);
  vdt.AddChildClassName(TDemandaAnioBaseEIndices.ClassName);

  tabsActores.Add(strTabDemandas, vdt);

  // Eolica
  vdt:=TVirtualTableTabs.Create(strTabEolica_);
  vdt.AddChildClassName(TParqueEolico.ClassName);
  vdt.AddChildClassName(TParqueEolico_vxy.ClassName);

  tabsActores.Add(strTabEolica_, vdt);

  // Solar
  vdt:=TVirtualTableTabs.Create(strTabSolar);
  vdt.AddChildClassName(TSolartermico.ClassName);
  vdt.AddChildClassName(TSolarPV.ClassName);

  tabsActores.Add(strTabSolar, vdt);

  // Termicos
  vdt:=TVirtualTableTabs.Create(strTabGeneradoresTermicos );
  vdt.AddChildClassName(TGTer_Basico.ClassName);
  vdt.AddChildClassName(TGTer_OnOffPorPaso.ClassName);
  vdt.AddChildClassName(TGTer_OnOffPorPoste.ClassName);
  vdt.AddChildClassName(TGTer_ArranqueParada.ClassName);
  vdt.AddChildClassName(TGTer_Basico_TRep.ClassName);
  vdt.AddChildClassName(TGTer_Basico_PyCVariable.ClassName);
  vdt.AddChildClassName(TGTer_OnOffPorPaso_ConRestricciones.ClassName);
  vdt.AddChildClassName(TGTer_combinado.ClassName);
  vdt.AddChildClassName(TBiomasaEmbalsable.ClassName);
  {$IFDEF COMBUSTIBLES}
  vdt.AddChildClassName(TGTer_OnOffPorPosteV2.ClassName);
  vdt.AddChildClassName(TGTer_OnOffPorPasoV2.ClassName);
  vdt.AddChildClassName(TGTer_ArranqueParadaV2.ClassName);
  vdt.AddChildClassName(TGTer_combinadoV2.ClassName);
  {$ENDIF}

  tabsActores.Add(strTabGeneradoresTermicos, vdt);

  // Hidraulicos
  vdt:=TVirtualTableTabs.Create(strTabGeneradoresHidraulicos );
  vdt.AddChildClassName(THidroConEmbalse.ClassName);
  vdt.AddChildClassName(THidroConBombeo.ClassName);
//  vdt.AddChildClassName(THidroConEmbalseValorizado.ClassName);
  vdt.AddChildClassName(THidroDePasada.ClassName);
  vdt.AddChildClassName(THidroConEmbalseBinacional.ClassName);

  tabsActores.Add(strTabGeneradoresHidraulicos, vdt);

  // Comercio internacional y otros
  vdt:=TVirtualTableTabs.Create(strTabComercioInternacionalYOtros );
  vdt.AddChildClassName(TMercadoSpot.ClassName);
  vdt.AddChildClassName(TMercadoSpotDetalleHorarioSemanal.ClassName);
  vdt.AddChildClassName(TContratoModalidadDevolucion.ClassName);
  vdt.AddChildClassName(TMercadoSpot_postizado.ClassName);
  vdt.AddChildClassName(TBancoDeBaterias01.ClassName);

  tabsActores.Add(strTabComercioInternacionalYOtros, vdt);

  // Usos gestionables
  vdt:=TVirtualTableTabs.Create(strTabUsosGestionables );
  vdt.AddChildClassName(TUsoGestionable_postizado.ClassName);

  tabsActores.Add(strTabUsosGestionables, vdt);

  // Usos gestionables
  vdt:=TVirtualTableTabs.Create(strTabSumCombustibles );
  vdt.AddChildClassName(TNodoCombustible.ClassName);

  tabsActores.Add(strTabSumCombustibles, vdt);

  // Demanda combustible
  vdt:=TVirtualTableTabs.Create(strTabSumCombustibles );
  vdt.AddChildClassName(TDemandaCombustibleAnioBaseEIndices.ClassName);
  vdt.AddChildClassName(TRegasificadora.ClassName);
  vdt.AddChildClassName(TArcoCombustible.ClassName);
  vdt.AddChildClassName(TGSimple_BiCombustible.ClassName);
  vdt.AddChildClassName(TSuministroSimpleCombustible.ClassName);

  tabsActores.Add(strTabSumCombustibles, vdt);

end;

{ TTabsActores }

function TTabsActores.Add(const TabCaption: shortstring; vdt: TVirtualTableTabs
  ): Integer;
begin
  Result:= inherited Add(TabCaption, vdt);
end;

function TTabsActores.Find(const TabCaption: shortstring): TDataVTableOfCosa;
begin
  Result:= inherited Find(TabCaption);
end;

function TTabsActores.TabsNames: TStringList;
var
  strlst: TStringList;
  i: Integer;
begin

  strlst:= TStringList.Create;
  for i:=0 to self.Count-1 do
    strlst.Add(self.NameOfIndex(i));

  Result:=strlst;

end;

{ TVirtualTableTabs }

constructor TVirtualTableTabs.Create(TabCaption: string);
var
  DataVColumnList: TDataColumnListOfCosa;
begin

  DataVColumnList:=TDataColumnListOfCosa.Create(nil);
  DataVColumnList.AddDataColumn('nombre', TDataTypeStringOfCosa);

  inherited Create('vdt_'+TabCaption, DataVColumnList);

end;

initialization

tabsActores:= TTabsActores.Create;
CrearTabsActores;

end.

