{+doc
+NOMBRE: MatBool
+CREACION: 6.1.1994
+AUTORES: rch @floresta
+REGISTRO:
+TIPO: Unidad Pascal.
+PROPOSITO: definicion del objeto MatBooliz de enteros.
+PROYECTO: rchlib

+REVISION:
+AUTOR:
+DESCRIPCION:
	Todas las tareas implementadas en esta biblioteca, tienen como
filosofia que los datos estan bien definidos, y para mejorar la
velocidad no verifican la coherencia. Tampoco se encargan de
inicializar MatBoolices. Supongamos que vamos a multiplicar las
MatBoolices A y B , y queremos el resultado en C, la sentecia es
C.MultM(A,B); pero se debe cuidar que los rangos sean los adecuados
y se debe inicializar C antes del llamado a MultMatBool.
	Las unicas tareas que inicializan  datos del objeto son las de
lectura. Ej: a.readM; inicialliza a.

-doc}

unit MatBool;

interface
uses
	{$I xobjects},
  xMatDefs, MatObj, horrores;

type
	
	PVectBool = ^TVectBool;
	TVectBool = object(TVect)
			constructor Init(ne:word);
			constructor Ventana( ne: word; var x );
			constructor Load( var S: TStream );
			function e(k:word):boolean;
			procedure pon_e(k:word; x:boolean);
			procedure or_e(k:word; x:boolean);
			procedure and_e(k:word; x:boolean);
			function PEV(var y :TVectBool):boolean;
			function PEVRFLX(var y:TVectBool): boolean;
			procedure AndBoolean(r:boolean);
      procedure OrBoolean(r: boolean );
			procedure orV(var y:TVectBool);
			procedure andV(var y:TVectBool);
			function ne2: NEntero; {norma euclideana al cuadrado }
			function normEuclid:NReal;
			function normMaxAbs:boolean;
			procedure Copy(var x:TVectBool);
			procedure Ceros; virtual;
			procedure MinMax(var kMin, kMax:word; var Min, Max:boolean);
			procedure Print;virtual;
	end;

const
	RVectBool: TStreamRec = ( ObjType: 4015;
	 VmtLink: Ofs(TypeOf(TVectBool)^);
	 Load:    @TVectBool.Load;
	 Store:   @TVectBool.Store
	);


type
	PMatBool = ^TMatBool;
	TMatBool = object(TMat)
    constructor Init(filas,columnas:word);
		constructor Load( var S: TStream );
		function e(k,j:word):boolean;
		procedure pon_e(k,j: integer; x: boolean);
		procedure or_e(k,j:integer; x: boolean);
		procedure and_e(k,j:integer; x: boolean);

		procedure Mult(a,b:TMatBool);
		procedure WriteM;
		constructor ReadM; (* a debe estar sin inicializar *)
		function Traza:boolean;
		procedure CopyColVect(var Y: TVectBool; J: Integer);
		procedure Ceros; virtual;
		procedure Unos; virtual; 
	end;

const
	RMatBool: TStreamRec = ( ObjType: 4006;
	 VmtLink: Ofs(TypeOf(TMatBool)^);
	 Load:    @TMatBool.Load;
	 Store:   @TMatBool.Store
	);


procedure RegisterMatBool;

implementation

procedure RegisterMatBool;
begin
	RegisterType(RVectBool);
	RegisterType(RMatBool);
end;



constructor TMatBool.Init;
begin
 TMat.init(filas,columnas,sizeof(boolean));
end;

constructor TMatBool.Load( var S: TStream );
begin
	TMat.Load(S);
end;

function TMatBool.e;
begin
 e:=boolean(pte(k,j)^)
end;

procedure TMatBool.pon_e(k,j: integer; x:boolean);
var
	p:pointer;
begin
	p:= pte(k,j);
	boolean(p^):=x;
end;

procedure TMatBool.Or_e(k,j: integer; x:boolean);
var
	p:pointer;
begin
	p:= pte(k,j);
	boolean(p^):=boolean(p^) or x;
end;

procedure TMatBool.And_e(k,j: integer; x:boolean);
var
	p:pointer;
begin
	p:= pte(k,j);
	boolean(p^):=boolean(p^) and x;
end;



constructor TVectBool.Init(ne:word);
begin
 TVect.init(ne,sizeof(boolean));
end;

constructor TVectBool.Load( var S: TStream );
begin
	TVect.Load(S);
end;

procedure TVectBool.Print;
var
	k:integer;
begin
	writeln(' TVectBool.print.inicio');
	TVect.Print;
	for k:= 1 to n do
		writeln(' N: ',k:6,' : ',e(k):12);
	writeln(' TVectBool.print.fin');
end;


constructor TVectBool.Ventana( ne: word; var x );
begin
	TVect.Ventana( ne, SizeOf(boolean), x);
end;

function TVectBool.e(k:word):boolean;
begin
	e:=boolean(pte(k)^);
end;

procedure TVectBool.pon_e(k:word; x:boolean);
var
	p:pointer;
begin
	p:= pte(k);
	boolean(p^):=x;
end;



procedure TVectBool.or_e(k:word; x:boolean);
var
	p:pointer;
begin
	p:= pte(k);
	boolean(p^):=x or boolean(p^);
end;

procedure TVectBool.and_e(k:word; x:boolean);
var
	p:pointer;
begin
	p:= pte(k);
	boolean(p^):=x and boolean(p^);
end;

procedure TMatBool.Ceros;
var
	k, j: integer;
begin
	for k:= 1 to nc do
		for j:= 1 to nf do pon_e(k,j, false);
end;

procedure TMatBool.Unos;
var
	k, j: integer;
begin
	for k:= 1 to nc do
		for j:= 1 to nf do pon_e(k,j, True);
end;

	
procedure TVectBool.Ceros;
var
	k:integer;
	p:pointer;
begin
	p:=pv;
	for k:= 1 to n do
	begin
		boolean(p^):=false;
		inc(p)
	end
end;


procedure TVectBool.MinMax( var kMin, kMax: word; var Min, Max:boolean);
var
	k:integer;
	p:pointer;
begin
	p:=pv;
	Min:= boolean(p^); kMin:=1;
	Max:= boolean(p^); kMax:=1;
	for k:= 1 to n do
	begin
		if boolean(p^)<min then
		begin
			Min := boolean(p^);
			kMin:=k
		end
		else
			if boolean(p^) > max then
			begin
				Max := boolean(p^);
				kMax:= k
			end;
		inc(p)
	end
end;


function TVectBool.PEV(var y :TVectBool):boolean;
var
 k:integer;
 p1,p2:pointer;
 temp:boolean;
begin
	p1:=pv;p2:=y.pv;
	temp:=false;
	for k:=1 to n do
	begin
		temp:=temp or (boolean(p1^) and boolean(p2^));
		inc(p1);y.inc(p2)
	end;
	PEV:=temp
end;  (* PEV *)


function TVectBool.PEVRFLX(var y:TVectBool): boolean;
var
 k:integer;
 p1,p2:pointer;
 temp:boolean;
begin
p1:=pv;p2:=y.pte(y.n);
temp:=false;
		 for k:=1 to n do
				begin
				temp:=temp or (boolean(p1^) and boolean(p2^));
			  inc(p1);y.dec(p2)
			  end;
PEVRFLX:=temp
end;  (* PEVRFLX *)



procedure TVectBool.Copy(var x:TVectBool);
var
	k:integer;
begin
	move(x.pv^,pv^,n*SizeOf(boolean));
end;

procedure TVectBool.orV(var y:TVectBool);
var
	k:integer;
	p1,p2:pointer;
begin
	p1:=pv; p2:=y.pv;
	for k:=1 to n do
	begin
		boolean(p1^):=boolean(p1^) or boolean(p2^);
		inc(p1); y.inc(p2)
	end
end;

procedure TVectBool.andV(var y:TVectBool);
var
	k:integer;
	p1,p2:pointer;
begin
	p1:=pv; p2:=y.pv;
	for k:=1 to n do
	begin
		boolean(p1^):=boolean(p1^) and boolean(p2^);
		inc(p1); y.inc(p2)
	end
end;



procedure TVectBool.AndBoolean(r:boolean);
var
	k:integer;
	p1:pointer;
begin
	p1:=pv;
	for k:=1 to n do
	begin
		boolean(p1^):=boolean(p1^) and r;
		inc(p1)
	end;
end;

procedure TVectBool.OrBoolean(r:boolean);
var
	k:integer;
	p1:pointer;
begin
	p1:=pv;
	for k:=1 to n do
	begin
		boolean(p1^):=boolean(p1^) Or r;
		inc(p1)
	end;
end;


function TVectBool.ne2:NEntero; {norma euclideana al cuadrado }
var
	k:integer;
	p1:pointer;
	acum: NEntero;
begin
	p1:=pv;
	acum:=0;
	for k:= 1 to n do
	begin
		if boolean(p1^) then	acum:= acum+1;
		inc(p1)
	end;
	ne2:=acum
end;

function TVectBool.normEuclid:NReal;
begin
	normEuclid:=sqrt(ne2)
end;

function TVectBool.normMaxAbs:boolean;
var
	k:integer;
	p1:pointer;
	maxA:boolean;
begin
	p1:=pv;
	maxA:= false;
	k:=1;
	while (k<=n)and(Not MaxA) do
	begin
		MaxA:=boolean(p1^);
		inc(p1)
	end;
	normMaxAbs:=maxA
end;


procedure TMatBool.WriteM;
var
   k,J:word;
begin
writeln;
writeln('---------------------------------------');
for k:=1 to nf do
	begin
	write('fila',k:3,'):');
	for j:=1 to nc do
		write(e(k,j):12);
	writeln;
	end;
end;


constructor TMatBool.ReadM; (* a debe estar sin inicializar *)
var
	 k,J:word;
	 dat: string;
   c: char;
begin
	writeln;
	writeln('---------------------------------------');
	write('numero de filas=?');readln(k);
	write('numero de columnas=?');readln(j);
	init(k,j);
	for k:=1 to nf do
	begin
		write('fila',k:3,'):?');
		for j:=1 to nc do
    begin
			read(dat);
			c:= UpCase(dat[1]);
			case c of
				'1','t','T','v','V': boolean(pte(k,j)^):=true;
				'0','f','F': boolean(pte(k,j)^):=false;
		else error('Formato booleano invlido');
      end;{ case }
			writeln;
		end;
	end;
end;




procedure TMatBool.CopyColVect(var Y: TVectBool; J: Integer);
var
	k:integer;
	p1,p2:pointer;
begin
p1:=y.pv;
for k:=1 to nf do
	begin
	boolean(p1^):=boolean(pte(k,j)^);
	y.inc(p1)
	end;
end;  (* CopyColVect *)



function TMatBool.Traza:boolean;
var
   k:integer;
	temp:boolean;
	p1:pointer;
begin
temp:=boolean(pte(1,1)^);
for k:=2 to nc do
	begin
	temp := temp or boolean(pte(k,k)^);
	end;
Traza:=temp
end; (* Traza *)



procedure TMatBool.Mult(a,b:TMatBool);
var
   k,j:integer;
	 v:TVectBool;
	 mtemp:TMatBool;
   pa,pb,pc:pointer;

begin

v.init(b.nf);
mtemp.init(a.nf,a.nc);
mtemp.igual(a);

for j:=1 to A.nc do
    begin
    pa:=mtemp.pv;
	 b.CopyColVect(v,j);
     for k:=1 to A.nf do
         begin
			boolean(pte(k,j)^):= v.PEV(TVectBool(pa^));
         mtemp.inc(pa);
         end;
    end;
mtemp.done;
v.done;
end;  (* MultTMatBool *)

end.